#!/usr/bin/env python

import os,string
import base

# Permet de chercher les methodes d'une classe dans son bon module !
def search_method(fichier_source, package_name, interface_name, orb, cible):

    fs = open(fichier_source,'r')
    result = []
    abstract = 0
    search_abstract = 1
    if (cible == "ABSTRACT"):
    	cible = "CLIENT"
        abstract = 1

    if cible != 'DIRECT':
    
        # On commence par chercher les caracteristiques de l'orb
        #
        real_class_name = orb_carac("CLASS_NAME_" + cible, orb)
        index = string.find(real_class_name,'NAME')
        real_class_name = real_class_name[:index] + interface_name + real_class_name[index+4:]
        #
        chaine_delimitant_la_classe = real_class_name + orb_carac("CLASS_DEL", orb) 
        fin_de_la_classe = orb_carac("CLASS_END", orb) + '\n'
        chaine_module = orb_carac("MODULE_DEF", orb)
    else:
        search_abstract = 0
        real_class_name = interface_name
        chaine_delimitant_la_classe = real_class_name + ' :'
        fin_de_la_classe = '};\n'
        chaine_module = 'namespace'

    package_name_save = package_name
    # On cherche la classe, puis on cherche les methodes
    # pour chaque methode, on cherche les arguments
    etape = 'cherche_module'
    if package_name == '' :
        etape = 'cherche_classe'
    arret = 0
    for s in fs.readlines():
        if etape == 'cherche_module':
            package_name_search = ''
            index2 = string.find(package_name, '::')
            if index2 == -1 :
                package_name_search = package_name
            else :
                package_name_search = package_name[:index2]
            index = string.find(s, chaine_module + ' ' + package_name_search)
            if index != -1:
                if index2 != -1 :
                    package_name = package_name[index2+2:]
                else :
                    package_name = ''
                if package_name == '':
                    etape = 'cherche_classe'
        if etape == 'cherche_classe':
            index = string.find(s, chaine_delimitant_la_classe)
            if index != -1:
                etape = 'cherche_methodes'
        if etape == 'cherche_methodes':
            if arret == 0:
                # condition d'arret : fin de la classe
                #if (s == fin_de_la_classe):
                if (string.find(s,fin_de_la_classe) != -1):
                    arret = 1
                else:
                    if search_abstract == 1 :
                        # On cherche les methodes significatives
                        index = string.find(s,' = 0;')
                        if index != -1:
                            methode = determine_real_method_name(s[:index], package_name_save, interface_name)
                            if abstract == 0:
                                result.append(methode + ';\n') 
                            else:
                                result.append(methode + ' = 0;\n')
                    else :
                        # On elimine les constructeurs
                        index = string.find(s,interface_name)
                        if index == -1:
                            index = string.find(s,'(')
                            if index != -1 :
                                methode = s
                                result.append(methode + '\n')
    # Fin
    fs.close()
    return result


# Permet de chercher une carac dans le fichier de configuration d'un orb particulier
def orb_carac(chaine, orb):
    fichier = os.environ['PACOPATH'] + '/ORB/' + orb + '/config'
    return base.search_macro(fichier, chaine)

# Permet de chercher une carac dans le fichier de configuration d'un orb particulier
def orb_carac_init(chaine, orb,srcdir):
    fichier = srcdir + '/ORB/' + orb + '/config'
    return base.search_macro(fichier, chaine)

# Cette fonction permet de trouver la nouvelle syntaxe des arguments  d'une methode
def determine_real_method_name(method, package_name, interface_name):
    # On commence par trouver les arguments
    index = string.find(method, '(')
    args = method[index+1:-1]
    args_final = ''
    nb_arg = string.count(method,',') + 1

    for i in range(nb_arg):
        temp = ''
        type_temp = ''
        debut_type_temp = ''
        index = string.find(args,',')
        if index != -1:
            # On retire de args l'argument analyse
            temp = args[:index]
            args = args[index+1:]
        else:
            temp = args
            # On recupere le type
        index_blanc = string.rfind(temp, ' ')
        type_temp = temp[:index_blanc]
        if string.find(type_temp, ' ') != -1 :
            index_blanc2 = string.rfind(type_temp, ' ')
            debut_type_temp = type_temp[:index_blanc2+1]
            type_temp = type_temp[index_blanc2+1:]
            
        # Il suffit maintenant de chercher la chaine complete !!!
        arg_type_name = ''
        namespace_name = ''
        index_name = string.find(type_temp,'::')
        if index_name == -1:
            arg_type_name = debut_type_temp + type_temp
        else :
            # On teste le cas interface_name::x
            first_namespace = type_temp[:index_name]
            if first_namespace == interface_name:
                arg_type_name = debut_type_temp + package_name + '::' + type_temp
            else :
                arg_type_name = debut_type_temp + type_temp
        if nb_arg == 1 :
            args_final = arg_type_name + temp[index_blanc:]
        else :
            if i == nb_arg-1 :
                args_final = args_final + ' ' +  arg_type_name + temp[index_blanc:]
            else :
                args_final = args_final + ' ' +  arg_type_name + temp[index_blanc:] + ','

    index = string.find(method, '(')
    return method[:index+1] + args_final + ')' 

# Cette fonction permet de retrouver le nom du premier
# argument dans la chaine arguments
# Elle retourne le triple : arguments ou l'argument trouver est enleve
# et le nom de l'argument et le type de l'argument

# Fonction a totalement refaire !!!!!!!!!!!!!!
def researchArgName(arguments, language='all'):

    # Dans cette methode, on suppose qu'il n'y a qu'un seul espace
    # A reecrire avec des regexp !!!!!!
    arg_idl = ''
    arg_name = ''
    arg_type = ''
    result = []
    index = string.find(arguments, ',')

    if index == -1:
        if arguments == "();" or arguments == "()":
            arguments = ''
        else:
            # objectif : Enlever les blancs !
            # Derriere
            index = string.find(arguments, ')')
	    if index>0:
            	arguments = arguments[:index]

            index2 = string.rfind(arguments, ' ')
            while index2 == index-1:
                index = index2
                arguments = arguments[:index2]
                index2 = string.rfind(arguments, ' ')


            # Devant
            index = string.find(arguments, '(')
            arguments = arguments[index+1:]
            index = string.find(arguments, ' ')
            while index == 0:
                arguments = arguments[1:]
                index = string.find(arguments, ' ')
            # Et hop !
            if language == 'idl' :
                index = string.find(arguments, ' ')
                arg_idl = arguments[:index]
                arguments = arguments[index+1:]
                index = string.find(arguments, ' ')
                arg_type = arguments[:index]
                arguments = arguments[index+1:]
                arg_name = arguments
            else :
                index_const = string.find(arguments, 'const')
                if index_const != -1:
                    arguments = arguments[index_const+6:]
                index = string.find(arguments, ' ')
                arg_type = arguments[:index]
                arguments = arguments[index+1:]
                index = string.find(arguments, ' ')
                if index == -1:
                    arg_name = arguments
                else :
                    arg_name = arguments[:index]

            arguments = ''
    else:
        arguments_temp = arguments[:index]
        arguments = arguments[index+1:]
	
	# On travaille que arguments_temp
#	index2 = string.rfind(arguments_temp, ' ')
#        while index2 == index2-1:
#            arguments_temp = arguments_temp[:index2]
#            index2 = string.rfind(arguments_temp, ' ')
	# Devant
	index = string.find(arguments_temp, '(')
	arguments_temp = arguments_temp[index+1:]
	index = string.find(arguments_temp, ' ')
	while index == 0:
	    arguments_temp = arguments_temp[1:]
	    index = string.find(arguments_temp, ' ')
 
	# Et hop !
        if language == 'idl' :
	    index = string.find(arguments_temp, ' ')
	    arg_idl = arguments_temp[:index]
	    arguments_temp = arguments_temp[index+1:]
	    index = string.find(arguments_temp, ' ')
	    arg_type = arguments_temp[:index]
	    arguments_temp = arguments_temp[index+1:]
	    arg_name = arguments_temp
        else :
	    index_const = string.find(arguments_temp, 'const')
	    if index_const != -1:
		arguments_temp = arguments_temp[index_const+6:]
	    index = string.find(arguments_temp, ' ')
	    arg_type = arguments_temp[:index]
	    arguments_temp = arguments_temp[index+1:]
	    index = string.find(arguments_temp, ' ')
	    if index == -1:
		arg_name = arguments_temp
	    else :
		arg_name = arguments_temp[:index]

    # delete &
    if string.find(arg_type,'&') != -1 :
        arg_type = arg_type[:-1]
    # delete (
    if string.find(arg_type,'(') != -1 :
        arg_type = arg_type[1:]

    result.append(arguments)
    result.append(arg_name)
    result.append(arg_type)
    if language == 'idl' :
        result.append(arg_idl)
    return result

def get_method_name(method_declaration) :
    # elimination du virtual
    chaine = method_declaration
    fin_virtual = string.find(chaine,'virtual ')
    chaine = chaine[fin_virtual+8:]
    
    # pt dans le nom
    fin_return = string.find(chaine,' ')
    fin_def = string.find(chaine,';')
    fin_nom = string.find(chaine,'(')
    
    # differentes chaines
    retour =  chaine[:fin_return]
    nom_methode_complet = chaine[fin_return+1:fin_def]
    nom_methode_simple = chaine[fin_return+1:fin_nom]
    arguments = chaine[fin_nom:]

    return nom_methode_simple

def get_arguments_number(method_declaration) :

    # elimination du virtual
    chaine = method_declaration
    fin_virtual = string.find(chaine,'virtual ')
    chaine = chaine[fin_virtual+8:]
    
    # pt dans le nom
    fin_return = string.find(chaine,' ')
    fin_def = string.find(chaine,';')
    fin_nom = string.find(chaine,'(')
    
    # differentes chaines
    retour =  chaine[:fin_return]
    nom_methode_complet = chaine[fin_return+1:fin_def]
    nom_methode_simple = chaine[fin_return+1:fin_nom]
    arguments = chaine[fin_nom:]
    arguments_number = str(string.count(arguments, ',') + 1)

    return arguments_number

def decompose_method(method_declaration, language) :

    chaine = method_declaration
    result = []
    
    if language == 'c++' :
        # elimination du virtual
        fin_virtual = string.find(chaine,'virtual ')
        chaine = chaine[fin_virtual+8:]
    
    # pt dans le nom
    fin_return = string.find(chaine,' ')
    while fin_return == 0:
        chaine = chaine[1:]
        fin_return = string.find(chaine,' ')
    retour = ''
    if language == 'idl':
        # Il faut tester s'il y a un oneway
        fin_oneway = string.find(chaine,'oneway')
        if fin_oneway != -1:
            retour = 'oneway '
            chaine = chaine[7:]
            fin_return = string.find(chaine,' ')
                   
    fin_def = string.find(chaine,';')
    fin_nom = string.find(chaine,'(')

    retour =  retour + chaine[:fin_return]
    nom_methode_complet = chaine[fin_return+1:fin_def]
    nom_methode_simple = chaine[fin_return+1:fin_nom]
    arguments = chaine[fin_nom:]

    # Arguments
    result.append(arguments)
    result.append(nom_methode_simple)
    result.append(retour)
    return result
    

