#!/usr/bin/env python

import os,string
import base
import complex


# Add to RealType[.h,.cc] the arg
def addArgToRealType(package_name, interface_name, operation_name, arg_name, real_type):

    temp_string = ''
    package_name_trans = string.replace(package_name,'::','_')
    
    # in RealType.h
    file = open('RealType.h', 'a+')
    
    if package_name != '' :
        temp_string = 'typedef ConcretTemplate<' + package_name + '::' + interface_name + '_PaCO::PaCOData_' + arg_name + ', '+ real_type + '> '+ package_name_trans + '_' + interface_name + '_'+ operation_name + '_' + arg_name + ';\n'
    else :
        temp_string = 'typedef ConcretTemplate<' + interface_name + '_PaCO::PaCOData_' + arg_name + ', '+ real_type + '> '+ package_name_trans + '_' + interface_name + '_'+ operation_name + '_' + arg_name + ';\n'
    file.write(temp_string)
    temp_string = 'typedef vConcretTemplate< ' + package_name_trans + '_' + interface_name +'_'+ operation_name +'_'+ arg_name + '> v' + package_name_trans + '_' + interface_name +'_'+ operation_name +'_'+ arg_name + ';\n'
    file.write(temp_string)
    temp_string = 'typedef ConcretPattronTemplate< ' + package_name_trans + '_' + interface_name +'_'+ operation_name +'_'+ arg_name + ', v' + package_name_trans + '_' + interface_name +'_'+ operation_name +'_'+ arg_name + '> ' + package_name_trans + '_' + interface_name +'_'+ operation_name +'_'+ arg_name + 'Pattron;\n'
    file.write(temp_string)
    file.close()
    
    # in RealType.cc
    file = open('RealType.cc', 'a+')
    temp_string = 'template ' + package_name_trans + '_' + interface_name +'_'+ operation_name +'_'+ arg_name + ';\n'
    file.write(temp_string)
    temp_string = 'template v' + package_name_trans + '_' + interface_name +'_'+ operation_name +'_'+ arg_name + ';\n'
    file.write(temp_string)
    temp_string = 'template ' + package_name_trans + '_' + interface_name +'_'+ operation_name +'_'+ arg_name + 'Pattron;\n'
    file.write(temp_string)
    file.close()
